<?php


class TwitterApi
{
    private $url_twitter;
    private $oauth_sig;

    public function __construct(){
        $this->url_twitter = 'https://api.twitter.com/2/tweets';
    }

    public function isOauth(){
        return (class_exists('OAuth')) ? true : false;
    }

    public function getOauthSig(){
        return $this->oauth_sig;
    }

    public function get_signature( $consumer_key, $consumer_secret, $token , $token_secret,$method = 'GET', $params = false ) {
            $nonce     = mt_rand();
            $timestamp = time();
            $oauth     = new \OAuth( $consumer_key, $consumer_secret );
            $oauth->setTimestamp( $timestamp );
            $oauth->setNonce( $nonce );
            $oauth->setToken( $token, $token_secret );
            $sig = $oauth->generateSignature( $method, $this->url_twitter, $params );
     
            $header = 'OAuth ' .
                'oauth_consumer_key="' . $consumer_key . '"' .
                ',oauth_signature_method="HMAC-SHA1"' .
                ',oauth_nonce="'. $nonce . '"' .
                ',oauth_timestamp="' . $timestamp . '"'.
                ',oauth_version="1.0"'.                  
                ',oauth_signature="' . urlencode( $sig ) . '"' .
                ',oauth_token="' . $token . '"' 
                ;
            
            $this->oauth_sig = $header;
            return $header;
    }

    public function twitterPost($status){
        $rr = json_encode(['text' => $status]);
        $args = [
            'body'        => $rr,
            'headers'     => [
                'Authorization' => $this->oauth_sig,
                'Content-Type' => 'application/json',
                'Accept' => '*/*'
            ],
        ];
       $response = wp_remote_post($this->url_twitter,$args );
       return $response;
    }
}
